#include "project.h"
#include "stdio.h"

#define STR_LEN 64
char str[STR_LEN+1] ;
void print(char *str)
{
    UART_PutString(str) ;
}

void cls(void)

{
    print("\033c") ; /* reset */
    CyDelay(100) ;
    print("\033[2J") ; /* clear screen */
    CyDelay(100) ;
}

void splash(void)
{
    cls() ;
    print("PSoC 6 SPI Test ") ;
    snprintf(str, STR_LEN, "(%s %s)\n", __DATE__, __TIME__) ;
    print(str) ;
}

void init_hardware(void)
{
    __enable_irq(); /* Enable global interrupts. */
    UART_Start() ;
    SPI_Start() ;
}

int main(void)
{
    int i = 0 ;
    uint16_t tx_data[2] = { 0x4444, 0x6666 } ;
    uint16_t rx_data = 0 ;
    uint16_t dummy = 0x0000 ;
    
    // __enable_irq(); /* Enable global interrupts. */
    /* Enable CM4.  CY_CORTEX_M4_APPL_ADDR must be updated if CM4 memory layout is changed. */
    // Cy_SysEnableCM4(CY_CORTEX_M4_APPL_ADDR); 
    init_hardware() ;
    
    splash() ;

    for(;;)
    {
        snprintf(str, STR_LEN, "Sending 0x%04X : ", tx_data[i]) ;
        print(str) ;
        SPI_Write(tx_data[i]) ;
        while(SPI_IsBusBusy()) ;
        SPI_Write(dummy) ;
        while(SPI_IsBusBusy()) ;
        i = (i + 1)%2 ; /* i = 0, 1, 0, 1... */
        rx_data = SPI_Read() ;
        snprintf(str, STR_LEN, "Received 0x%04X\n", rx_data) ;
        print(str) ;
        dummy = SPI_Read() ;
        CyDelay(1000) ;
    }
}

/* [] END OF FILE */
